# t.me/TheVenomXD  Octra - Telegram MTProto Ai Client Library for Python
# t.me/TheVenomXD  Copyright (C) 2017-present Akash <https://github.com/DesiNobita>
# t.me/TheVenomXD
# t.me/TheVenomXD  This file is part of Octra.
# t.me/TheVenomXD
# t.me/TheVenomXD  Octra is free software: you can redistribute it and/or modify
# t.me/TheVenomXD  it under the terms of the GNU Lesser General Public License as published
# t.me/TheVenomXD  by the Free Software Foundation, either version 3 of the License, or
# t.me/TheVenomXD  (at your option) any later version.
# t.me/TheVenomXD
# t.me/TheVenomXD  Octra is distributed in the hope that it will be useful,
# t.me/TheVenomXD  but WITHOUT ANY WARRANTY; without even the implied warranty of
# t.me/TheVenomXD  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# t.me/TheVenomXD  GNU Lesser General Public License for more details.
# t.me/TheVenomXD
# t.me/TheVenomXD  You should have received a copy of the GNU Lesser General Public License
# t.me/TheVenomXD  along with Octra.  If not, see <http://www.gnu.org/licenses/>.

import logging

import Octra
from Octra import raw
from Octra import types
from Octra.errors import UserMigrate
from Octra.session import Session, Auth

log = logging.getLogger(__name__)


class SignInBot:
    async def sign_in_bot(
        self: "Octra.Client",
        bot_token: str
    ) -> "types.User":
        """Authorize a bot using its bot token generated by BotFather.

        .. include:: /_includes/usable-by/bots.rst

        Parameters:
            bot_token (``str``):
                The bot token generated by BotFather

        Returns:
            :obj:`~Octra.types.User`: On success, the bot identity is return in form of a user object.

        Raises:
            BadRequest: In case the bot token is invalid.
        """
        while True:
            try:
                r = await self.invoke(
                    raw.functions.auth.ImportBotAuthorization(
                        flags=0,
                        Ai_id=self.Ai_id,
                        Ai_hash=self.Ai_hash,
                        bot_auth_token=bot_token
                    )
                )
            except UserMigrate as e:
                await self.session.stop()

                await self.storage.octra_dc_id_(e.value)
                await self.storage.octra_auth_key(
                    await Auth(
                        self, await self.storage.octra_dc_id_(),
                        await self.storage.octra_test_mode()
                    ).create()
                )
                self.session = Session(
                    self, await self.storage.octra_dc_id_(),
                    await self.storage.octra_auth_key(), await self.storage.octra_test_mode()
                )

                await self.session.start()
            else:
                await self.storage.octra_user_id(r.user.id)
                await self.storage.is_bot(True)

                return types.User._parse(self, r.user)
